package com.pahomov.CardsAndOther;

import android.animation.Animator;
import android.animation.AnimatorInflater;
import android.app.Activity;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.RippleDrawable;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.ActivityOptionsCompat;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.transition.Slide;
import android.transition.Transition;
import android.util.Log;
import android.view.View;
import android.view.ViewAnimationUtils;
import android.widget.ImageView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import butterknife.Bind;
import butterknife.ButterKnife;

public class MainActivity extends Activity {

    @Bind(R.id.rv)
    RecyclerView rv;
    @Bind(R.id.logo)
    ImageView logo;
    private List<ItemData> persons;
    int newPerson;
   // private RecyclerView rv;
    public RVAdapter adapter;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().requestFeature(android.view.Window.FEATURE_CONTENT_TRANSITIONS);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        rv=(RecyclerView)findViewById(R.id.rv);
       //final CardView cv = (CardView)findViewById(R.id.item);
        LinearLayoutManager llm = new LinearLayoutManager(this);
        rv.setLayoutManager(llm);
        rv.setHasFixedSize(true);
        final FloatingActionButton fab = (FloatingActionButton)findViewById(R.id.fab);
        fab.setBackgroundTintMode(PorterDuff.Mode.DARKEN);
        initializeData();
        adapter= new RVAdapter(persons);
        rv.setAdapter(adapter);
       rv.addOnItemTouchListener(
               new RecyclerItemClickListener(this, new RecyclerItemClickListener.OnItemClickListener() {
                   @Override
                   public void onItemClick(View view, int position) {
                       //persons.remove(position);
                       //  adapter.notifyItemRemoved(position);
                       Toast.makeText(getApplicationContext(), "clicked " + position, Toast.LENGTH_LONG).show();
                       int cx = view.getWidth() / 2;
                       int cy = view.getHeight() / 2;
                       Animator anim =
                               ViewAnimationUtils.createCircularReveal(view, cx, cy, Math.max(cx, cy), 0);
                       anim.start();
                       persons.remove(position);
                       adapter.notifyItemRemoved(position);


                   }
               })
       );

        rv.setStateListAnimator(AnimatorInflater.loadStateListAnimator(this, R.anim.raise));

        Transition ts = new Slide();

        ts.setStartDelay(2000);
        ts.setDuration(5000);
        getWindow().setEnterTransition(ts);
        getWindow().setExitTransition(ts);

        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.e("FAB", "Fab clicked");
                // persons.add(new ItemData("Lavery Maiss", "25 years old", R.drawable.lavery));
                //adapter.notifyDataSetChanged();
                Random r = new Random();
               addPerson(r.nextInt(3));



            }
        });
        logo.setClickable(true);

        RippleDrawable rippledImage = new
                RippleDrawable(ColorStateList.valueOf(Color.BLACK), logo.getDrawable(), null);
        logo.setImageDrawable(rippledImage);
        logo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent transitionIntent = new Intent(MainActivity.this, secondActivity.class);
                ActivityOptionsCompat options = ActivityOptionsCompat.makeCustomAnimation(MainActivity.this,R.anim.slide_in_right,R.anim.slide_out_left);
                startActivityForResult(transitionIntent, 31337, options.toBundle());


            }
        });
    }



    private void addPerson(int id)
    {
        switch(id){
            case 0:
                persons.add(new ItemData("#200", "September", R.drawable.x200s));
                break;
            case 1:
                persons.add(new ItemData("#201", "October", R.drawable.x201s));
                break;
            case 2:
                persons.add(new ItemData("#202", "November", R.drawable.x202s));
                break;
        }

        adapter.notifyDataSetChanged();
    }



    private void initializeData(){
        persons = new ArrayList<>();
        persons.add(new ItemData("#200", "September", R.drawable.x200s));
        persons.add(new ItemData("#201", "October", R.drawable.x201s));
        persons.add(new ItemData("#202", "November", R.drawable.x202s));

    }


}
