package com.pahomov.CardsAndOther;

import android.graphics.drawable.BitmapDrawable;
import android.support.v7.graphics.Palette;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

public class RVAdapter extends RecyclerView.Adapter<RVAdapter.ItemVH> {

    public  class ItemVH extends RecyclerView.ViewHolder {

       // CardView cv;


        TextView title;
        TextView descr;
        ImageView itemImage;

        ItemVH(View itemView) {
            super(itemView);
          //  cv = (CardView)itemView.findViewById(R.id.item);
            title = (TextView)itemView.findViewById(R.id.itemTitle);
            descr = (TextView)itemView.findViewById(R.id.itemText);
            itemImage = (ImageView)itemView.findViewById(R.id.itemImage);
        }
    }

    List<ItemData> items;

    RVAdapter(List<ItemData> items){
        this.items = items;
    }



    @Override
    public void onAttachedToRecyclerView(RecyclerView recyclerView) {
        super.onAttachedToRecyclerView(recyclerView);
    }


    @Override
    public ItemVH onCreateViewHolder(ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.item, viewGroup, false);

        ItemVH pvh = new ItemVH(v);
        return pvh;
    }




    @Override
    public void onBindViewHolder(final ItemVH itemVH, int i) {
        itemVH.title.setText(items.get(i).title);
        itemVH.descr.setText(items.get(i).descr);
        itemVH.itemImage.setImageResource(items.get(i).photoId);
        BitmapDrawable bD=(BitmapDrawable)itemVH.itemImage.getDrawable();

        Palette.generateAsync( bD.getBitmap(),
                new Palette.PaletteAsyncListener() {
                    @Override
                    public void onGenerated(Palette palette) {
                        Palette.Swatch vibrant =
                                palette.getVibrantSwatch();
                        if (vibrant != null) {

                            itemVH.title.setTextColor(
                                    vibrant.getTitleTextColor());
                            itemVH.descr.setTextColor(
                                    vibrant.getTitleTextColor());
                        }
                    }
                });
    }

    @Override
    public int getItemCount() {
        return items.size();
    }


}
